module.exports = class Request {
    constructor() {
        this.completed = false;
    }

    get(url, callback) {
        const request = new XMLHttpRequest();

        // Set up the callback for when the response comes in
        request.onreadystatechange = () => {
            if (request.readyState === 4) {
                this.completed = true;
                if (request.status === 200) {
                    callback(null, request.responseText);
                } else {
                    callback(new Error(`Request failed with status ${request.status}: ${request.statusText}`), null);
                }
            }
        }

        // Open the request, as asynchronous
        request.open("GET", url, true);

        // Send the request
        request.send(null);
    }
}